<html>
<head>
<title>OGRE: OgreMesh.h Source File - OGRE Documentation</title> <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"> 
<link type="text/css" rel="stylesheet" href="doxygen.css">
<link type="text/css" rel="stylesheet" href="tabs.css">
</head>

<body>
<!-- Generated by Doxygen 1.5.3 -->
<div class="tabs">
  <ul>
    <li><a href="index.html"><span>Main&nbsp;Page</span></a></li>
    <li><a href="namespaces.html"><span>Namespaces</span></a></li>
    <li><a href="classes.html"><span>Classes</span></a></li>
    <li class="current"><a href="files.html"><span>Files</span></a></li>
    <li><a href="dirs.html"><span>Directories</span></a></li>
    <li><a href="pages.html"><span>Related&nbsp;Pages</span></a></li>
  </ul>
</div>
<div class="nav">
<a class="el" href="dir_d6c9b501d36b850bf0bac687671293db.html">OgreMain</a>&nbsp;&raquo&nbsp;<a class="el" href="dir_f35e1e76cd4423745a1cccb1f171d4e3.html">include</a></div>
<h1>OgreMesh.h</h1><a href="OgreMesh_8h.html">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*</span>
<a name="l00002"></a>00002 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00003"></a>00003 <span class="comment">This source file is part of OGRE</span>
<a name="l00004"></a>00004 <span class="comment">    (Object-oriented Graphics Rendering Engine)</span>
<a name="l00005"></a>00005 <span class="comment">For the latest info, see http://www.ogre3d.org/</span>
<a name="l00006"></a>00006 <span class="comment"></span>
<a name="l00007"></a>00007 <span class="comment">Copyright (c) 2000-2006 Torus Knot Software Ltd</span>
<a name="l00008"></a>00008 <span class="comment">Also see acknowledgements in Readme.html</span>
<a name="l00009"></a>00009 <span class="comment"></span>
<a name="l00010"></a>00010 <span class="comment">This program is free software; you can redistribute it and/or modify it under</span>
<a name="l00011"></a>00011 <span class="comment">the terms of the GNU Lesser General Public License as published by the Free Software</span>
<a name="l00012"></a>00012 <span class="comment">Foundation; either version 2 of the License, or (at your option) any later</span>
<a name="l00013"></a>00013 <span class="comment">version.</span>
<a name="l00014"></a>00014 <span class="comment"></span>
<a name="l00015"></a>00015 <span class="comment">This program is distributed in the hope that it will be useful, but WITHOUT</span>
<a name="l00016"></a>00016 <span class="comment">ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS</span>
<a name="l00017"></a>00017 <span class="comment">FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more details.</span>
<a name="l00018"></a>00018 <span class="comment"></span>
<a name="l00019"></a>00019 <span class="comment">You should have received a copy of the GNU Lesser General Public License along with</span>
<a name="l00020"></a>00020 <span class="comment">this program; if not, write to the Free Software Foundation, Inc., 59 Temple</span>
<a name="l00021"></a>00021 <span class="comment">Place - Suite 330, Boston, MA 02111-1307, USA, or go to</span>
<a name="l00022"></a>00022 <span class="comment">http://www.gnu.org/copyleft/lesser.txt.</span>
<a name="l00023"></a>00023 <span class="comment"></span>
<a name="l00024"></a>00024 <span class="comment">You may alternatively use this source under the terms of a specific version of</span>
<a name="l00025"></a>00025 <span class="comment">the OGRE Unrestricted License provided you have obtained such a license from</span>
<a name="l00026"></a>00026 <span class="comment">Torus Knot Software Ltd.</span>
<a name="l00027"></a>00027 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00028"></a>00028 <span class="comment">*/</span>
<a name="l00029"></a>00029 <span class="preprocessor">#ifndef __Mesh_H__</span>
<a name="l00030"></a>00030 <span class="preprocessor"></span><span class="preprocessor">#define __Mesh_H__</span>
<a name="l00031"></a>00031 <span class="preprocessor"></span>
<a name="l00032"></a>00032 <span class="preprocessor">#include "<a class="code" href="OgrePrerequisites_8h.html">OgrePrerequisites.h</a>"</span>
<a name="l00033"></a>00033 
<a name="l00034"></a>00034 <span class="preprocessor">#include "<a class="code" href="OgreResource_8h.html">OgreResource.h</a>"</span>
<a name="l00035"></a>00035 <span class="preprocessor">#include "<a class="code" href="OgreVertexIndexData_8h.html">OgreVertexIndexData.h</a>"</span>
<a name="l00036"></a>00036 <span class="preprocessor">#include "<a class="code" href="OgreAxisAlignedBox_8h.html">OgreAxisAlignedBox.h</a>"</span>
<a name="l00037"></a>00037 <span class="preprocessor">#include "<a class="code" href="OgreVertexBoneAssignment_8h.html">OgreVertexBoneAssignment.h</a>"</span>
<a name="l00038"></a>00038 <span class="preprocessor">#include "<a class="code" href="OgreIteratorWrappers_8h.html">OgreIteratorWrappers.h</a>"</span>
<a name="l00039"></a>00039 <span class="preprocessor">#include "<a class="code" href="OgreProgressiveMesh_8h.html">OgreProgressiveMesh.h</a>"</span>
<a name="l00040"></a>00040 <span class="preprocessor">#include "<a class="code" href="OgreHardwareVertexBuffer_8h.html">OgreHardwareVertexBuffer.h</a>"</span>
<a name="l00041"></a>00041 <span class="preprocessor">#include "<a class="code" href="OgreSkeleton_8h.html">OgreSkeleton.h</a>"</span>
<a name="l00042"></a>00042 <span class="preprocessor">#include "<a class="code" href="OgreAnimationTrack_8h.html">OgreAnimationTrack.h</a>"</span>
<a name="l00043"></a>00043 <span class="preprocessor">#include "<a class="code" href="OgrePose_8h.html">OgrePose.h</a>"</span>
<a name="l00044"></a>00044 
<a name="l00045"></a>00045 
<a name="l00046"></a>00046 <span class="keyword">namespace </span>Ogre {
<a name="l00047"></a>00047 
<a name="l00048"></a>00048 
<a name="l00083"></a>00083     <span class="keyword">struct </span>MeshLodUsage;
<a name="l00084"></a>00084 
<a name="l00085"></a><a class="code" href="classOgre_1_1Mesh.html">00085</a>     <span class="keyword">class </span><a class="code" href="OgrePlatform_8h.html#20566b1253bae200372ed9162489a663">_OgreExport</a> <a class="code" href="classOgre_1_1Mesh.html">Mesh</a>: <span class="keyword">public</span> <a class="code" href="classOgre_1_1Resource.html" title="Abstract class reprensenting a loadable resource (e.g.">Resource</a>
<a name="l00086"></a>00086     {
<a name="l00087"></a><a class="code" href="classOgre_1_1Mesh.html#1d5fbbc16bf26f6a94d018b087d4db7e">00087</a>         <span class="keyword">friend</span> <span class="keyword">class </span><a class="code" href="classOgre_1_1SubMesh.html" title="Defines a part of a complete mesh.">SubMesh</a>;
<a name="l00088"></a><a class="code" href="classOgre_1_1Mesh.html#48305c54a01e0c7a3376ea0a077c467f">00088</a>         <span class="keyword">friend</span> <span class="keyword">class </span><a class="code" href="classOgre_1_1MeshSerializerImpl.html" title="Internal implementation of Mesh reading / writing for the latest version of the ...">MeshSerializerImpl</a>;
<a name="l00089"></a><a class="code" href="classOgre_1_1Mesh.html#e60e96165c5d5495195fa0d49f031372">00089</a>         <span class="keyword">friend</span> <span class="keyword">class </span><a class="code" href="classOgre_1_1MeshSerializerImpl__v1__2.html" title="Class for providing backwards-compatibility for loading version 1.2 of the .mesh...">MeshSerializerImpl_v1_2</a>;
<a name="l00090"></a><a class="code" href="classOgre_1_1Mesh.html#ef9901d67ded13a151aa3d4fde3a7b17">00090</a>         <span class="keyword">friend</span> <span class="keyword">class </span><a class="code" href="classOgre_1_1MeshSerializerImpl__v1__1.html" title="Class for providing backwards-compatibility for loading version 1.1 of the .mesh...">MeshSerializerImpl_v1_1</a>;
<a name="l00091"></a>00091 
<a name="l00092"></a>00092     <span class="keyword">public</span>:
<a name="l00093"></a><a class="code" href="classOgre_1_1Mesh.html#99a8bd0d2f2fe430776df7230271a521">00093</a>         <span class="keyword">typedef</span> std::vector&lt;Real&gt; LodDistanceList;
<a name="l00095"></a><a class="code" href="classOgre_1_1Mesh.html#ed02a800a3f1fc668dd5da422a219ef8">00095</a>         <span class="keyword">typedef</span> std::multimap&lt;size_t, VertexBoneAssignment&gt; VertexBoneAssignmentList;
<a name="l00096"></a><a class="code" href="classOgre_1_1Mesh.html#87ffd99faf08ec80bd6932ac77381f3f">00096</a>         <span class="keyword">typedef</span> <a class="code" href="classOgre_1_1MapIterator.html" title="Wraps iteration over a map.">MapIterator&lt;VertexBoneAssignmentList&gt;</a> <a class="code" href="classOgre_1_1MapIterator.html" title="Wraps iteration over a map.">BoneAssignmentIterator</a>;
<a name="l00097"></a><a class="code" href="classOgre_1_1Mesh.html#adf4f5fb8b74f46ca0fe5dfb530a5f64">00097</a>         <span class="keyword">typedef</span> std::vector&lt;SubMesh*&gt; SubMeshList;
<a name="l00098"></a><a class="code" href="classOgre_1_1Mesh.html#9394fdee4f4f3cc760d44fa165b088c2">00098</a>         <span class="keyword">typedef</span> std::vector&lt;unsigned short&gt; IndexMap;
<a name="l00099"></a>00099 
<a name="l00100"></a>00100     <span class="keyword">protected</span>:
<a name="l00107"></a><a class="code" href="classOgre_1_1Mesh.html#7ca5d3840b1139163678c69accd610e8">00107</a>         SubMeshList mSubMeshList;
<a name="l00108"></a>00108     
<a name="l00110"></a>00110         <span class="keywordtype">void</span> organiseTangentsBuffer(<a class="code" href="classOgre_1_1VertexData.html" title="Summary class collecting together vertex source information.">VertexData</a> *vertexData, 
<a name="l00111"></a>00111             <a class="code" href="namespaceOgre.html#0a62b3f2ede8992ff365bb013a8bc00d" title="Vertex element semantics, used to identify the meaning of vertex buffer contents...">VertexElementSemantic</a> targetSemantic, <span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> index, 
<a name="l00112"></a>00112             <span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> sourceTexCoordSet);
<a name="l00113"></a>00113 
<a name="l00114"></a>00114     <span class="keyword">public</span>:
<a name="l00118"></a><a class="code" href="classOgre_1_1Mesh.html#001584a126b2a78e15a2b3b9e9ee8433">00118</a>         <span class="keyword">typedef</span> HashMap&lt;String, ushort&gt; SubMeshNameMap ;
<a name="l00119"></a>00119 
<a name="l00120"></a>00120         
<a name="l00121"></a>00121     <span class="keyword">protected</span>:
<a name="l00122"></a><a class="code" href="classOgre_1_1Mesh.html#5e06f63dfac01346d8a045448af28407">00122</a>         SubMeshNameMap mSubMeshNameMap ;
<a name="l00123"></a>00123 
<a name="l00125"></a><a class="code" href="classOgre_1_1Mesh.html#9786a87341b9b5954382f956749f598a">00125</a>         <a class="code" href="classOgre_1_1AxisAlignedBox.html" title="A 3D box aligned with the x/y/z axes.">AxisAlignedBox</a> mAABB;
<a name="l00127"></a><a class="code" href="classOgre_1_1Mesh.html#fa81b36baa8be6c84ab68c8b949a28bb">00127</a>         <a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> mBoundRadius;
<a name="l00128"></a>00128 
<a name="l00130"></a><a class="code" href="classOgre_1_1Mesh.html#bf86b0682730527681abfe665fa63f52">00130</a>         <a class="code" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> mSkeletonName;
<a name="l00131"></a><a class="code" href="classOgre_1_1Mesh.html#1f273987d25be940aa9e4381b7984a67">00131</a>         <a class="code" href="classOgre_1_1SkeletonPtr.html" title="Specialisation of SharedPtr to allow SharedPtr to be assigned to SkeletonPtr.">SkeletonPtr</a> mSkeleton;
<a name="l00132"></a>00132 
<a name="l00133"></a>00133        
<a name="l00134"></a><a class="code" href="classOgre_1_1Mesh.html#ecb0a3ad72dfe057752755a3be9a9d62">00134</a>         VertexBoneAssignmentList mBoneAssignments;
<a name="l00135"></a>00135 
<a name="l00137"></a><a class="code" href="classOgre_1_1Mesh.html#e36b7dbb1a019f7e74f7f7723e2f3b39">00137</a>         <span class="keywordtype">bool</span> mBoneAssignmentsOutOfDate;
<a name="l00138"></a>00138 
<a name="l00140"></a>00140         <span class="keywordtype">void</span> buildIndexMap(<span class="keyword">const</span> VertexBoneAssignmentList&amp; boneAssignments,
<a name="l00141"></a>00141             IndexMap&amp; boneIndexToBlendIndexMap, IndexMap&amp; blendIndexToBoneIndexMap);
<a name="l00143"></a>00143         <span class="keywordtype">void</span> compileBoneAssignments(<span class="keyword">const</span> VertexBoneAssignmentList&amp; boneAssignments,
<a name="l00144"></a>00144             <span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> numBlendWeightsPerVertex, 
<a name="l00145"></a>00145             IndexMap&amp; blendIndexToBoneIndexMap,
<a name="l00146"></a>00146             <a class="code" href="classOgre_1_1VertexData.html" title="Summary class collecting together vertex source information.">VertexData</a>* targetVertexData);
<a name="l00147"></a>00147 
<a name="l00148"></a><a class="code" href="classOgre_1_1Mesh.html#9b6f3fc61ca0d2d2672b47a16fc47fff">00148</a>         <span class="keywordtype">bool</span> mIsLodManual;
<a name="l00149"></a><a class="code" href="classOgre_1_1Mesh.html#57579011f3db548f4d096735298b171d">00149</a>         <a class="code" href="namespaceOgre.html#f851e71354d841df7138f9877c6f5931">ushort</a> mNumLods;
<a name="l00150"></a><a class="code" href="classOgre_1_1Mesh.html#5895cc4a48a728812531f3cc90e40412">00150</a>         <span class="keyword">typedef</span> std::vector&lt;MeshLodUsage&gt; MeshLodUsageList;
<a name="l00151"></a><a class="code" href="classOgre_1_1Mesh.html#df2df0fe279913f67a2fd07a01bc5263">00151</a>         MeshLodUsageList mMeshLodUsageList;
<a name="l00152"></a>00152 
<a name="l00153"></a><a class="code" href="classOgre_1_1Mesh.html#50c4b46dec40e7433a9c3bd2a0349c59">00153</a>         <a class="code" href="classOgre_1_1HardwareBuffer.html#e51f5970d879af736e4cf53e1ec46630" title="Enums describing buffer usage; not mutually exclusive.">HardwareBuffer::Usage</a> mVertexBufferUsage;
<a name="l00154"></a><a class="code" href="classOgre_1_1Mesh.html#e321765ebd25dfb980ea8fa749bb9195">00154</a>         <a class="code" href="classOgre_1_1HardwareBuffer.html#e51f5970d879af736e4cf53e1ec46630" title="Enums describing buffer usage; not mutually exclusive.">HardwareBuffer::Usage</a> mIndexBufferUsage;
<a name="l00155"></a><a class="code" href="classOgre_1_1Mesh.html#4d241fb1ac0e9bb6d9d510a879296fd2">00155</a>         <span class="keywordtype">bool</span> mVertexBufferShadowBuffer;
<a name="l00156"></a><a class="code" href="classOgre_1_1Mesh.html#bde99137ff08e231b5ae13217b8c876e">00156</a>         <span class="keywordtype">bool</span> mIndexBufferShadowBuffer;
<a name="l00157"></a>00157 
<a name="l00158"></a>00158 
<a name="l00159"></a><a class="code" href="classOgre_1_1Mesh.html#6f094394f60ba564ffc0e15998187481">00159</a>         <span class="keywordtype">bool</span> mPreparedForShadowVolumes;
<a name="l00160"></a><a class="code" href="classOgre_1_1Mesh.html#8e05383eefb4a20985626ae26f4676af">00160</a>         <span class="keywordtype">bool</span> mEdgeListsBuilt;
<a name="l00161"></a><a class="code" href="classOgre_1_1Mesh.html#e82cdb664edcbebb241153913ff4ab12">00161</a>         <span class="keywordtype">bool</span> mAutoBuildEdgeLists;
<a name="l00162"></a>00162 
<a name="l00164"></a><a class="code" href="classOgre_1_1Mesh.html#4b0e7a62d413f362142c612cd14f94d7">00164</a>         <span class="keyword">typedef</span> std::map&lt;String, Animation*&gt; AnimationList;
<a name="l00165"></a><a class="code" href="classOgre_1_1Mesh.html#cac70b5bd5092cb00478bfc439e36c26">00165</a>         AnimationList mAnimationsList;
<a name="l00167"></a><a class="code" href="classOgre_1_1Mesh.html#6c96921fb54638cedc2300fbe5ba50a2">00167</a>         <span class="keyword">mutable</span> <a class="code" href="namespaceOgre.html#9046e6e0d12c46c57a9056987e9d158e" title="Type of vertex animation.">VertexAnimationType</a> mSharedVertexDataAnimationType;
<a name="l00169"></a><a class="code" href="classOgre_1_1Mesh.html#d6fda574da726cc8861408341ab65261">00169</a>         <span class="keyword">mutable</span> <span class="keywordtype">bool</span> mAnimationTypesDirty;
<a name="l00170"></a>00170 
<a name="l00172"></a><a class="code" href="classOgre_1_1Mesh.html#828d80c76f0e26edb7ea699d1c919818">00172</a>         <a class="code" href="namespaceOgre.html#8f03b49c53cbcc1d22f4ef3abfb5b1eb">PoseList</a> mPoseList;
<a name="l00173"></a>00173 
<a name="l00174"></a>00174 
<a name="l00176"></a>00176         <span class="keywordtype">void</span> loadImpl(<span class="keywordtype">void</span>);
<a name="l00178"></a>00178         <span class="keywordtype">void</span> postLoadImpl(<span class="keywordtype">void</span>);
<a name="l00180"></a>00180         <span class="keywordtype">void</span> unloadImpl(<span class="keywordtype">void</span>);
<a name="l00182"></a>00182         <span class="keywordtype">size_t</span> calculateSize(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00183"></a>00183 
<a name="l00184"></a>00184 
<a name="l00185"></a>00185 
<a name="l00186"></a>00186     <span class="keyword">public</span>:
<a name="l00191"></a>00191         <a class="code" href="classOgre_1_1Mesh.html">Mesh</a>(<a class="code" href="classOgre_1_1ResourceManager.html" title="Defines a generic resource handler.">ResourceManager</a>* creator, <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; name, <a class="code" href="namespaceOgre.html#a1814a97f96347b215b50c11ac2ad09b">ResourceHandle</a> handle,
<a name="l00192"></a>00192             <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; group, <span class="keywordtype">bool</span> isManual = <span class="keyword">false</span>, <a class="code" href="classOgre_1_1ManualResourceLoader.html" title="Interface describing a manual resource loader.">ManualResourceLoader</a>* loader = 0);
<a name="l00193"></a>00193         ~<a class="code" href="classOgre_1_1Mesh.html">Mesh</a>();
<a name="l00194"></a>00194 
<a name="l00195"></a>00195         <span class="comment">// NB All methods below are non-virtual since they will be</span>
<a name="l00196"></a>00196         <span class="comment">// called in the rendering loop - speed is of the essence.</span>
<a name="l00197"></a>00197 
<a name="l00204"></a>00204         <a class="code" href="classOgre_1_1SubMesh.html" title="Defines a part of a complete mesh.">SubMesh</a>* createSubMesh(<span class="keywordtype">void</span>);
<a name="l00205"></a>00205 
<a name="l00208"></a>00208         <a class="code" href="classOgre_1_1SubMesh.html" title="Defines a part of a complete mesh.">SubMesh</a>* createSubMesh(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; name);
<a name="l00209"></a>00209         
<a name="l00212"></a>00212         <span class="keywordtype">void</span> nameSubMesh(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; name, <a class="code" href="namespaceOgre.html#f851e71354d841df7138f9877c6f5931">ushort</a> index);
<a name="l00213"></a>00213         
<a name="l00219"></a>00219         <a class="code" href="namespaceOgre.html#f851e71354d841df7138f9877c6f5931">ushort</a> _getSubMeshIndex(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; name) <span class="keyword">const</span>;
<a name="l00220"></a>00220 
<a name="l00223"></a>00223         <span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> getNumSubMeshes(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00224"></a>00224 
<a name="l00227"></a>00227         <a class="code" href="classOgre_1_1SubMesh.html" title="Defines a part of a complete mesh.">SubMesh</a>* getSubMesh(<span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> index) <span class="keyword">const</span>;
<a name="l00228"></a>00228 
<a name="l00231"></a>00231         <a class="code" href="classOgre_1_1SubMesh.html" title="Defines a part of a complete mesh.">SubMesh</a>* getSubMesh(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; name) <span class="keyword">const</span> ;
<a name="l00232"></a>00232 
<a name="l00233"></a><a class="code" href="classOgre_1_1Mesh.html#c3955099a61b444cb9a2e7e111a1f271">00233</a>         <span class="keyword">typedef</span> <a class="code" href="classOgre_1_1VectorIterator.html" title="Wraps iteration over a vector.">VectorIterator&lt;SubMeshList&gt;</a> <a class="code" href="classOgre_1_1VectorIterator.html" title="Wraps iteration over a vector.">SubMeshIterator</a>;
<a name="l00235"></a><a class="code" href="classOgre_1_1Mesh.html#1891dd7442acc39c7edbf6a064e61b70">00235</a>         <a class="code" href="classOgre_1_1VectorIterator.html" title="Wraps iteration over a vector.">SubMeshIterator</a> getSubMeshIterator(<span class="keywordtype">void</span>)
<a name="l00236"></a>00236         { <span class="keywordflow">return</span> <a class="code" href="classOgre_1_1VectorIterator.html" title="Wraps iteration over a vector.">SubMeshIterator</a>(mSubMeshList.begin(), mSubMeshList.end()); }
<a name="l00237"></a>00237       
<a name="l00246"></a><a class="code" href="classOgre_1_1Mesh.html#1fd9968ccd424f913a7f3f68639f3ecf">00246</a>         <a class="code" href="classOgre_1_1VertexData.html" title="Summary class collecting together vertex source information.">VertexData</a> *sharedVertexData;
<a name="l00247"></a>00247 
<a name="l00268"></a><a class="code" href="classOgre_1_1Mesh.html#a9a6fc00032943a35fd293b5c664929e">00268</a>         IndexMap sharedBlendIndexToBoneIndexMap;
<a name="l00269"></a>00269 
<a name="l00279"></a>00279         <a class="code" href="classOgre_1_1MeshPtr.html" title="Specialisation of SharedPtr to allow SharedPtr to be assigned to MeshPtr.">MeshPtr</a> clone(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; newName, <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; newGroup = <a class="code" href="classOgre_1_1StringUtil.html#d2ead745c8c6f4f7056270e22f29e4da" title="Constant blank string, useful for returning by ref where local does not exist.">StringUtil::BLANK</a>);
<a name="l00280"></a>00280 
<a name="l00283"></a>00283         <span class="keyword">const</span> <a class="code" href="classOgre_1_1AxisAlignedBox.html" title="A 3D box aligned with the x/y/z axes.">AxisAlignedBox</a>&amp; getBounds(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00284"></a>00284 
<a name="l00286"></a>00286         <a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> getBoundingSphereRadius(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00287"></a>00287 
<a name="l00296"></a>00296         <span class="keywordtype">void</span> _setBounds(<span class="keyword">const</span> <a class="code" href="classOgre_1_1AxisAlignedBox.html" title="A 3D box aligned with the x/y/z axes.">AxisAlignedBox</a>&amp; bounds, <span class="keywordtype">bool</span> pad = <span class="keyword">true</span>);
<a name="l00297"></a>00297 
<a name="l00305"></a>00305         <span class="keywordtype">void</span> _setBoundingSphereRadius(<a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> radius);
<a name="l00306"></a>00306 
<a name="l00317"></a>00317         <span class="keywordtype">void</span> setSkeletonName(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; skelName);
<a name="l00318"></a>00318 
<a name="l00320"></a>00320         <span class="keywordtype">bool</span> hasSkeleton(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00321"></a>00321 
<a name="l00324"></a>00324         <span class="keywordtype">bool</span> hasVertexAnimation(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00325"></a>00325 
<a name="l00329"></a>00329         <span class="keyword">const</span> <a class="code" href="classOgre_1_1SkeletonPtr.html" title="Specialisation of SharedPtr to allow SharedPtr to be assigned to SkeletonPtr.">SkeletonPtr</a>&amp; getSkeleton(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00330"></a>00330 
<a name="l00332"></a>00332         <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; getSkeletonName(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00337"></a>00337         <span class="keywordtype">void</span> _initAnimationState(<a class="code" href="classOgre_1_1AnimationStateSet.html" title="Class encapsulating a set of AnimationState objects.">AnimationStateSet</a>* animSet);
<a name="l00338"></a>00338 
<a name="l00343"></a>00343         <span class="keywordtype">void</span> _refreshAnimationState(<a class="code" href="classOgre_1_1AnimationStateSet.html" title="Class encapsulating a set of AnimationState objects.">AnimationStateSet</a>* animSet);
<a name="l00356"></a>00356         <span class="keywordtype">void</span> addBoneAssignment(<span class="keyword">const</span> <a class="code" href="structOgre_1_1VertexBoneAssignment__s.html" title="Records the assignment of a single vertex to a single bone with the corresponding...">VertexBoneAssignment</a>&amp; vertBoneAssign);
<a name="l00357"></a>00357 
<a name="l00363"></a>00363         <span class="keywordtype">void</span> clearBoneAssignments(<span class="keywordtype">void</span>);
<a name="l00364"></a>00364 
<a name="l00371"></a>00371         <span class="keywordtype">void</span> _notifySkeleton(<a class="code" href="classOgre_1_1SkeletonPtr.html" title="Specialisation of SharedPtr to allow SharedPtr to be assigned to SkeletonPtr.">SkeletonPtr</a>&amp; pSkel);
<a name="l00372"></a>00372 
<a name="l00373"></a>00373 
<a name="l00376"></a>00376         <a class="code" href="classOgre_1_1MapIterator.html" title="Wraps iteration over a map.">BoneAssignmentIterator</a> getBoneAssignmentIterator(<span class="keywordtype">void</span>);
<a name="l00377"></a>00377 
<a name="l00378"></a>00378 
<a name="l00402"></a>00402         <span class="keywordtype">void</span> generateLodLevels(<span class="keyword">const</span> LodDistanceList&amp; lodDistances, 
<a name="l00403"></a>00403             <a class="code" href="classOgre_1_1ProgressiveMesh.html#c8ade932d6a3a6b24c7b7ad33c32a8e3" title="The way to derive the quota of vertices which are reduced at each LOD.">ProgressiveMesh::VertexReductionQuota</a> reductionMethod, <a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> reductionValue);
<a name="l00404"></a>00404 
<a name="l00409"></a>00409         <a class="code" href="namespaceOgre.html#f851e71354d841df7138f9877c6f5931">ushort</a> getNumLodLevels(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00411"></a>00411         <span class="keyword">const</span> <a class="code" href="structOgre_1_1MeshLodUsage.html" title="A way of recording the way each LODs is recorded this Mesh.">MeshLodUsage</a>&amp; getLodLevel(<a class="code" href="namespaceOgre.html#f851e71354d841df7138f9877c6f5931">ushort</a> index) <span class="keyword">const</span>;
<a name="l00425"></a>00425         <span class="keywordtype">void</span> createManualLodLevel(<a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> fromDepth, <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; meshName);
<a name="l00426"></a>00426 
<a name="l00434"></a>00434         <span class="keywordtype">void</span> updateManualLodLevel(<a class="code" href="namespaceOgre.html#f851e71354d841df7138f9877c6f5931">ushort</a> index, <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; meshName);
<a name="l00435"></a>00435 
<a name="l00438"></a>00438         <a class="code" href="namespaceOgre.html#f851e71354d841df7138f9877c6f5931">ushort</a> getLodIndex(<a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> depth) <span class="keyword">const</span>;
<a name="l00439"></a>00439 
<a name="l00446"></a>00446         <a class="code" href="namespaceOgre.html#f851e71354d841df7138f9877c6f5931">ushort</a> getLodIndexSquaredDepth(<a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> squaredDepth) <span class="keyword">const</span>;
<a name="l00447"></a>00447 
<a name="l00454"></a><a class="code" href="classOgre_1_1Mesh.html#f19a6a2ea5d033850fc575b2e9452d3d">00454</a>         <span class="keywordtype">bool</span> isLodManual(<span class="keywordtype">void</span>)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mIsLodManual; }
<a name="l00455"></a>00455 
<a name="l00457"></a>00457         <span class="keywordtype">void</span> _setLodInfo(<span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> numLevels, <span class="keywordtype">bool</span> isManual);
<a name="l00459"></a>00459         <span class="keywordtype">void</span> _setLodUsage(<span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> level, <a class="code" href="structOgre_1_1MeshLodUsage.html" title="A way of recording the way each LODs is recorded this Mesh.">MeshLodUsage</a>&amp; usage);
<a name="l00461"></a>00461         <span class="keywordtype">void</span> _setSubMeshLodFaceList(<span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> subIdx, <span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> level, <a class="code" href="classOgre_1_1IndexData.html" title="Summary class collecting together index data source information.">IndexData</a>* facedata);
<a name="l00462"></a>00462 
<a name="l00464"></a>00464         <span class="keywordtype">void</span> removeLodLevels(<span class="keywordtype">void</span>);
<a name="l00465"></a>00465 
<a name="l00488"></a>00488         <span class="keywordtype">void</span> setVertexBufferPolicy(<a class="code" href="classOgre_1_1HardwareBuffer.html#e51f5970d879af736e4cf53e1ec46630" title="Enums describing buffer usage; not mutually exclusive.">HardwareBuffer::Usage</a> usage, <span class="keywordtype">bool</span> shadowBuffer = <span class="keyword">false</span>);
<a name="l00511"></a>00511         <span class="keywordtype">void</span> setIndexBufferPolicy(<a class="code" href="classOgre_1_1HardwareBuffer.html#e51f5970d879af736e4cf53e1ec46630" title="Enums describing buffer usage; not mutually exclusive.">HardwareBuffer::Usage</a> usage, <span class="keywordtype">bool</span> shadowBuffer = <span class="keyword">false</span>);
<a name="l00513"></a><a class="code" href="classOgre_1_1Mesh.html#8e53e203cdf12cc40d746399e1f17c49">00513</a>         <a class="code" href="classOgre_1_1HardwareBuffer.html#e51f5970d879af736e4cf53e1ec46630" title="Enums describing buffer usage; not mutually exclusive.">HardwareBuffer::Usage</a> getVertexBufferUsage(<span class="keywordtype">void</span>)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mVertexBufferUsage; }
<a name="l00515"></a><a class="code" href="classOgre_1_1Mesh.html#3402c383107c83903f42d165163ac9e1">00515</a>         <a class="code" href="classOgre_1_1HardwareBuffer.html#e51f5970d879af736e4cf53e1ec46630" title="Enums describing buffer usage; not mutually exclusive.">HardwareBuffer::Usage</a> getIndexBufferUsage(<span class="keywordtype">void</span>)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mIndexBufferUsage; }
<a name="l00517"></a><a class="code" href="classOgre_1_1Mesh.html#a662df545eb8df490864316667ce1da2">00517</a>         <span class="keywordtype">bool</span> isVertexBufferShadowed(<span class="keywordtype">void</span>)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mVertexBufferShadowBuffer; }
<a name="l00519"></a><a class="code" href="classOgre_1_1Mesh.html#f91ff1e6396fc2aa6ca42ffeda910794">00519</a>         <span class="keywordtype">bool</span> isIndexBufferShadowed(<span class="keywordtype">void</span>)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mIndexBufferShadowBuffer; }
<a name="l00520"></a>00520        
<a name="l00521"></a>00521 
<a name="l00535"></a>00535         <span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> _rationaliseBoneAssignments(<span class="keywordtype">size_t</span> vertexCount, VertexBoneAssignmentList&amp; assignments);
<a name="l00536"></a>00536 
<a name="l00544"></a>00544         <span class="keywordtype">void</span> _compileBoneAssignments(<span class="keywordtype">void</span>);
<a name="l00545"></a>00545 
<a name="l00551"></a>00551         <span class="keywordtype">void</span> _updateCompiledBoneAssignments(<span class="keywordtype">void</span>);
<a name="l00552"></a>00552 
<a name="l00574"></a>00574         <span class="keywordtype">void</span> buildTangentVectors(<a class="code" href="namespaceOgre.html#0a62b3f2ede8992ff365bb013a8bc00d" title="Vertex element semantics, used to identify the meaning of vertex buffer contents...">VertexElementSemantic</a> targetSemantic = <a class="code" href="namespaceOgre.html#0a62b3f2ede8992ff365bb013a8bc00d57d43012049b3ec7b4240b207dd029f2" title="Tangent (X axis if normal is Z).">VES_TANGENT</a>,
<a name="l00575"></a>00575             <span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> sourceTexCoordSet = 0, <span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> index = 0);
<a name="l00576"></a>00576 
<a name="l00595"></a>00595         <span class="keywordtype">bool</span> suggestTangentVectorBuildParams(<a class="code" href="namespaceOgre.html#0a62b3f2ede8992ff365bb013a8bc00d" title="Vertex element semantics, used to identify the meaning of vertex buffer contents...">VertexElementSemantic</a> targetSemantic,
<a name="l00596"></a>00596             <span class="keywordtype">unsigned</span> <span class="keywordtype">short</span>&amp; outSourceCoordSet, <span class="keywordtype">unsigned</span> <span class="keywordtype">short</span>&amp; outIndex);
<a name="l00597"></a>00597 
<a name="l00601"></a>00601         <span class="keywordtype">void</span> buildEdgeList(<span class="keywordtype">void</span>);
<a name="l00603"></a>00603         <span class="keywordtype">void</span> freeEdgeList(<span class="keywordtype">void</span>);
<a name="l00604"></a>00604 
<a name="l00623"></a>00623         <span class="keywordtype">void</span> prepareForShadowVolume(<span class="keywordtype">void</span>);
<a name="l00624"></a>00624 
<a name="l00631"></a>00631         <a class="code" href="classOgre_1_1EdgeData.html" title="This class contains the information required to describe the edge connectivity of...">EdgeData</a>* getEdgeList(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> lodIndex = 0);
<a name="l00632"></a>00632 
<a name="l00639"></a>00639         <span class="keyword">const</span> <a class="code" href="classOgre_1_1EdgeData.html" title="This class contains the information required to describe the edge connectivity of...">EdgeData</a>* getEdgeList(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> lodIndex = 0) <span class="keyword">const</span>;
<a name="l00640"></a>00640 
<a name="l00643"></a><a class="code" href="classOgre_1_1Mesh.html#349d98f2e2668dfa630075123af7e90c">00643</a>         <span class="keywordtype">bool</span> isPreparedForShadowVolumes(<span class="keywordtype">void</span>)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mPreparedForShadowVolumes; }
<a name="l00644"></a>00644 
<a name="l00646"></a><a class="code" href="classOgre_1_1Mesh.html#b54aeef34c76386d3b42c88ba42eb69c">00646</a>         <span class="keywordtype">bool</span> isEdgeListBuilt(<span class="keywordtype">void</span>)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mEdgeListsBuilt; }
<a name="l00647"></a>00647 
<a name="l00659"></a>00659         <span class="keyword">static</span> <span class="keywordtype">void</span> prepareMatricesForVertexBlend(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Matrix4.html" title="Class encapsulating a standard 4x4 homogenous matrix.">Matrix4</a>** blendMatrices,
<a name="l00660"></a>00660             <span class="keyword">const</span> <a class="code" href="classOgre_1_1Matrix4.html" title="Class encapsulating a standard 4x4 homogenous matrix.">Matrix4</a>* boneMatrices, <span class="keyword">const</span> IndexMap&amp; indexMap);
<a name="l00661"></a>00661 
<a name="l00680"></a>00680         <span class="keyword">static</span> <span class="keywordtype">void</span> softwareVertexBlend(<span class="keyword">const</span> <a class="code" href="classOgre_1_1VertexData.html" title="Summary class collecting together vertex source information.">VertexData</a>* sourceVertexData, 
<a name="l00681"></a>00681             <span class="keyword">const</span> <a class="code" href="classOgre_1_1VertexData.html" title="Summary class collecting together vertex source information.">VertexData</a>* targetVertexData,
<a name="l00682"></a>00682             <span class="keyword">const</span> <a class="code" href="classOgre_1_1Matrix4.html" title="Class encapsulating a standard 4x4 homogenous matrix.">Matrix4</a>* <span class="keyword">const</span>* blendMatrices, <span class="keywordtype">size_t</span> numMatrices,
<a name="l00683"></a>00683             <span class="keywordtype">bool</span> blendNormals);
<a name="l00684"></a>00684 
<a name="l00697"></a>00697         <span class="keyword">static</span> <span class="keywordtype">void</span> softwareVertexMorph(<a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> t, 
<a name="l00698"></a>00698             <span class="keyword">const</span> <a class="code" href="classOgre_1_1HardwareVertexBufferSharedPtr.html" title="Shared pointer implementation used to share index buffers.">HardwareVertexBufferSharedPtr</a>&amp; b1, 
<a name="l00699"></a>00699             <span class="keyword">const</span> <a class="code" href="classOgre_1_1HardwareVertexBufferSharedPtr.html" title="Shared pointer implementation used to share index buffers.">HardwareVertexBufferSharedPtr</a>&amp; b2, 
<a name="l00700"></a>00700             <a class="code" href="classOgre_1_1VertexData.html" title="Summary class collecting together vertex source information.">VertexData</a>* targetVertexData);
<a name="l00701"></a>00701 
<a name="l00716"></a>00716         <span class="keyword">static</span> <span class="keywordtype">void</span> softwareVertexPoseBlend(<a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> weight, 
<a name="l00717"></a>00717             <span class="keyword">const</span> std::map&lt;size_t, Vector3&gt;&amp; vertexOffsetMap,
<a name="l00718"></a>00718             <a class="code" href="classOgre_1_1VertexData.html" title="Summary class collecting together vertex source information.">VertexData</a>* targetVertexData);
<a name="l00720"></a><a class="code" href="classOgre_1_1Mesh.html#df1de56b022a41ca399588951c7bb1c2">00720</a>         <span class="keyword">const</span> SubMeshNameMap&amp; getSubMeshNameMap(<span class="keywordtype">void</span>)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mSubMeshNameMap; }
<a name="l00721"></a>00721 
<a name="l00732"></a><a class="code" href="classOgre_1_1Mesh.html#c4f3cb35c7eebbe35d5734c8e3682c7d">00732</a>         <span class="keywordtype">void</span> setAutoBuildEdgeLists(<span class="keywordtype">bool</span> autobuild) { mAutoBuildEdgeLists = autobuild; }
<a name="l00737"></a><a class="code" href="classOgre_1_1Mesh.html#c799c7cc93cb9a7f36427207767dfaa6">00737</a>         <span class="keywordtype">bool</span> getAutoBuildEdgeLists(<span class="keywordtype">void</span>)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mAutoBuildEdgeLists; }
<a name="l00738"></a>00738 
<a name="l00741"></a>00741         <span class="keyword">virtual</span> <a class="code" href="namespaceOgre.html#9046e6e0d12c46c57a9056987e9d158e" title="Type of vertex animation.">VertexAnimationType</a> getSharedVertexDataAnimationType(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00742"></a>00742 
<a name="l00747"></a>00747         <span class="keyword">virtual</span> <a class="code" href="classOgre_1_1Animation.html" title="An animation sequence.">Animation</a>* createAnimation(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; name, <a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> length);
<a name="l00748"></a>00748 
<a name="l00752"></a>00752         <span class="keyword">virtual</span> <a class="code" href="classOgre_1_1Animation.html" title="An animation sequence.">Animation</a>* getAnimation(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; name) <span class="keyword">const</span>;
<a name="l00753"></a>00753 
<a name="l00758"></a>00758         <span class="keyword">virtual</span> <a class="code" href="classOgre_1_1Animation.html" title="An animation sequence.">Animation</a>* _getAnimationImpl(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; name) <span class="keyword">const</span>;
<a name="l00759"></a>00759 
<a name="l00761"></a>00761         <span class="keyword">virtual</span> <span class="keywordtype">bool</span> hasAnimation(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; name);
<a name="l00762"></a>00762 
<a name="l00764"></a>00764         <span class="keyword">virtual</span> <span class="keywordtype">void</span> removeAnimation(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; name);
<a name="l00765"></a>00765 
<a name="l00767"></a>00767         <span class="keyword">virtual</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> getNumAnimations(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00768"></a>00768 
<a name="l00771"></a>00771         <span class="keyword">virtual</span> <a class="code" href="classOgre_1_1Animation.html" title="An animation sequence.">Animation</a>* getAnimation(<span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> index) <span class="keyword">const</span>;
<a name="l00772"></a>00772 
<a name="l00774"></a>00774         <span class="keyword">virtual</span> <span class="keywordtype">void</span> removeAllAnimations(<span class="keywordtype">void</span>);
<a name="l00780"></a>00780         <a class="code" href="classOgre_1_1VertexData.html" title="Summary class collecting together vertex source information.">VertexData</a>* getVertexDataByTrackHandle(<span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> handle);
<a name="l00792"></a>00792         <span class="keywordtype">void</span> updateMaterialForAllSubMeshes(<span class="keywordtype">void</span>);
<a name="l00793"></a>00793 
<a name="l00798"></a>00798         <span class="keywordtype">void</span> _determineAnimationTypes(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00800"></a><a class="code" href="classOgre_1_1Mesh.html#aa46f04cb1ba0263ac8c09b0b614a75c">00800</a>         <span class="keywordtype">bool</span> _getAnimationTypesDirty(<span class="keywordtype">void</span>)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mAnimationTypesDirty; }
<a name="l00801"></a>00801 
<a name="l00808"></a>00808         <a class="code" href="classOgre_1_1Pose.html" title="A pose is a linked set of vertex offsets applying to one set of vertex data.">Pose</a>* createPose(<a class="code" href="namespaceOgre.html#f851e71354d841df7138f9877c6f5931">ushort</a> target, <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; name = <a class="code" href="classOgre_1_1StringUtil.html#d2ead745c8c6f4f7056270e22f29e4da" title="Constant blank string, useful for returning by ref where local does not exist.">StringUtil::BLANK</a>);
<a name="l00810"></a><a class="code" href="classOgre_1_1Mesh.html#76dd3ef52e65e59b69abc55030674bc2">00810</a>         <span class="keywordtype">size_t</span> getPoseCount(<span class="keywordtype">void</span>)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mPoseList.size(); }
<a name="l00812"></a>00812         <a class="code" href="classOgre_1_1Pose.html" title="A pose is a linked set of vertex offsets applying to one set of vertex data.">Pose</a>* getPose(<a class="code" href="namespaceOgre.html#f851e71354d841df7138f9877c6f5931">ushort</a> index);
<a name="l00814"></a>00814         <a class="code" href="classOgre_1_1Pose.html" title="A pose is a linked set of vertex offsets applying to one set of vertex data.">Pose</a>* getPose(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; name);
<a name="l00818"></a>00818         <span class="keywordtype">void</span> removePose(<a class="code" href="namespaceOgre.html#f851e71354d841df7138f9877c6f5931">ushort</a> index);
<a name="l00822"></a>00822         <span class="keywordtype">void</span> removePose(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; name);
<a name="l00824"></a>00824         <span class="keywordtype">void</span> removeAllPoses(<span class="keywordtype">void</span>);
<a name="l00825"></a>00825 
<a name="l00826"></a><a class="code" href="classOgre_1_1Mesh.html#78f32e7c485e681dce9422b69186960f">00826</a>         <span class="keyword">typedef</span> <a class="code" href="classOgre_1_1VectorIterator.html" title="Wraps iteration over a vector.">VectorIterator&lt;PoseList&gt;</a> <a class="code" href="classOgre_1_1VectorIterator.html" title="Wraps iteration over a vector.">PoseIterator</a>;
<a name="l00827"></a><a class="code" href="classOgre_1_1Mesh.html#1c651712526bfe4999f27c6c18ded1d9">00827</a>         <span class="keyword">typedef</span> <a class="code" href="classOgre_1_1ConstVectorIterator.html" title="Wraps iteration over a const vector.">ConstVectorIterator&lt;PoseList&gt;</a> <a class="code" href="classOgre_1_1ConstVectorIterator.html" title="Wraps iteration over a const vector.">ConstPoseIterator</a>;
<a name="l00828"></a>00828 
<a name="l00830"></a>00830         <a class="code" href="classOgre_1_1VectorIterator.html" title="Wraps iteration over a vector.">PoseIterator</a> getPoseIterator(<span class="keywordtype">void</span>);
<a name="l00832"></a>00832         <a class="code" href="classOgre_1_1ConstVectorIterator.html" title="Wraps iteration over a const vector.">ConstPoseIterator</a> getPoseIterator(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00834"></a>00834         <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#8f03b49c53cbcc1d22f4ef3abfb5b1eb">PoseList</a>&amp; getPoseList(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00835"></a>00835 
<a name="l00836"></a>00836     };
<a name="l00837"></a>00837 
<a name="l00844"></a><a class="code" href="classOgre_1_1MeshPtr.html">00844</a>     <span class="keyword">class </span><a class="code" href="OgrePlatform_8h.html#20566b1253bae200372ed9162489a663">_OgreExport</a> <a class="code" href="classOgre_1_1MeshPtr.html" title="Specialisation of SharedPtr to allow SharedPtr to be assigned to MeshPtr.">MeshPtr</a> : <span class="keyword">public</span> <a class="code" href="classOgre_1_1SharedPtr.html" title="Reference-counted shared pointer, used for objects where implicit destruction is...">SharedPtr</a>&lt;Mesh&gt; 
<a name="l00845"></a>00845     {
<a name="l00846"></a>00846     <span class="keyword">public</span>:
<a name="l00847"></a><a class="code" href="classOgre_1_1MeshPtr.html#bbec119ed3bb38b54bb66e38f2ea2b1c">00847</a>         <a class="code" href="classOgre_1_1MeshPtr.html" title="Specialisation of SharedPtr to allow SharedPtr to be assigned to MeshPtr.">MeshPtr</a>() : <a class="code" href="classOgre_1_1SharedPtr.html" title="Reference-counted shared pointer, used for objects where implicit destruction is...">SharedPtr</a>&lt;<a class="code" href="classOgre_1_1Mesh.html">Mesh</a>&gt;() {}
<a name="l00848"></a><a class="code" href="classOgre_1_1MeshPtr.html#2f1add9de3a418de7ba564491697b93e">00848</a>         <span class="keyword">explicit</span> <a class="code" href="classOgre_1_1MeshPtr.html" title="Specialisation of SharedPtr to allow SharedPtr to be assigned to MeshPtr.">MeshPtr</a>(<a class="code" href="classOgre_1_1Mesh.html">Mesh</a>* rep) : <a class="code" href="classOgre_1_1SharedPtr.html" title="Reference-counted shared pointer, used for objects where implicit destruction is...">SharedPtr</a>&lt;<a class="code" href="classOgre_1_1Mesh.html">Mesh</a>&gt;(rep) {}
<a name="l00849"></a><a class="code" href="classOgre_1_1MeshPtr.html#4fdd20db6401f38a40b1ebfe6c97ab9b">00849</a>         <a class="code" href="classOgre_1_1MeshPtr.html" title="Specialisation of SharedPtr to allow SharedPtr to be assigned to MeshPtr.">MeshPtr</a>(<span class="keyword">const</span> <a class="code" href="classOgre_1_1MeshPtr.html" title="Specialisation of SharedPtr to allow SharedPtr to be assigned to MeshPtr.">MeshPtr</a>&amp; r) : <a class="code" href="classOgre_1_1SharedPtr.html" title="Reference-counted shared pointer, used for objects where implicit destruction is...">SharedPtr</a>&lt;<a class="code" href="classOgre_1_1Mesh.html">Mesh</a>&gt;(r) {} 
<a name="l00850"></a>00850         <a class="code" href="classOgre_1_1MeshPtr.html" title="Specialisation of SharedPtr to allow SharedPtr to be assigned to MeshPtr.">MeshPtr</a>(<span class="keyword">const</span> <a class="code" href="classOgre_1_1SharedPtr.html" title="Reference-counted shared pointer, used for objects where implicit destruction is...">ResourcePtr</a>&amp; r);
<a name="l00852"></a>00852         <a class="code" href="classOgre_1_1MeshPtr.html" title="Specialisation of SharedPtr to allow SharedPtr to be assigned to MeshPtr.">MeshPtr</a>&amp; operator=(<span class="keyword">const</span> <a class="code" href="classOgre_1_1SharedPtr.html" title="Reference-counted shared pointer, used for objects where implicit destruction is...">ResourcePtr</a>&amp; r);
<a name="l00853"></a>00853     <span class="keyword">protected</span>:
<a name="l00855"></a>00855         <span class="keywordtype">void</span> destroy(<span class="keywordtype">void</span>);
<a name="l00856"></a>00856     };
<a name="l00857"></a>00857 
<a name="l00859"></a><a class="code" href="structOgre_1_1MeshLodUsage.html">00859</a>     <span class="keyword">struct </span><a class="code" href="structOgre_1_1MeshLodUsage.html" title="A way of recording the way each LODs is recorded this Mesh.">MeshLodUsage</a>
<a name="l00860"></a>00860     {
<a name="l00862"></a><a class="code" href="structOgre_1_1MeshLodUsage.html#d66b926054e26a4ac0eb4ec250e0334e">00862</a>         <a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> <a class="code" href="structOgre_1_1MeshLodUsage.html#d66b926054e26a4ac0eb4ec250e0334e" title="squared Z value from which this LOD will apply">fromDepthSquared</a>;
<a name="l00864"></a><a class="code" href="structOgre_1_1MeshLodUsage.html#7fb356beacea9effe6462ef8b14d5f72">00864</a>         <a class="code" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> <a class="code" href="structOgre_1_1MeshLodUsage.html#7fb356beacea9effe6462ef8b14d5f72" title="Only relevant if mIsLodManual is true, the name of the alternative mesh to use.">manualName</a>;
<a name="l00866"></a><a class="code" href="structOgre_1_1MeshLodUsage.html#5749654233531c2be7509f795321504f">00866</a>         <span class="keyword">mutable</span> <a class="code" href="classOgre_1_1MeshPtr.html" title="Specialisation of SharedPtr to allow SharedPtr to be assigned to MeshPtr.">MeshPtr</a> <a class="code" href="structOgre_1_1MeshLodUsage.html#5749654233531c2be7509f795321504f" title="Hard link to mesh to avoid looking up each time.">manualMesh</a>;
<a name="l00868"></a><a class="code" href="structOgre_1_1MeshLodUsage.html#e42184abf768e9c0cf42458112f2c082">00868</a>         <span class="keyword">mutable</span> <a class="code" href="classOgre_1_1EdgeData.html" title="This class contains the information required to describe the edge connectivity of...">EdgeData</a>* <a class="code" href="structOgre_1_1MeshLodUsage.html#e42184abf768e9c0cf42458112f2c082" title="Edge list for this LOD level (may be derived from manual mesh).">edgeData</a>;
<a name="l00869"></a>00869     };
<a name="l00870"></a>00870 
<a name="l00871"></a>00871 
<a name="l00872"></a>00872 
<a name="l00873"></a>00873 } <span class="comment">// namespace</span>
<a name="l00874"></a>00874 
<a name="l00875"></a>00875 <span class="preprocessor">#endif</span>
</pre></div><hr>
<p>
Copyright &copy; 2000-2005 by The OGRE Team<br />
<!--Creative Commons License--><a rel="license" href="http://creativecommons.org/licenses/by-sa/2.5/"><img alt="Creative Commons License" border="0" src="http://creativecommons.org/images/public/somerights20.png"/></a><br/>
This work is licensed under a <a rel="license" href="http://creativecommons.org/licenses/by-sa/2.5/">Creative Commons Attribution-ShareAlike 2.5 License</a>.<br/>
		<!--/Creative Commons License--><!-- <rdf:RDF xmlns="http://web.resource.org/cc/" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#">
		<Work rdf:about="">
			<license rdf:resource="http://creativecommons.org/licenses/by-sa/2.5/" />
	<dc:type rdf:resource="http://purl.org/dc/dcmitype/Text" />
		</Work>
		<License rdf:about="http://creativecommons.org/licenses/by-sa/2.5/"><permits rdf:resource="http://web.resource.org/cc/Reproduction"/><permits rdf:resource="http://web.resource.org/cc/Distribution"/><requires rdf:resource="http://web.resource.org/cc/Notice"/><requires rdf:resource="http://web.resource.org/cc/Attribution"/><permits rdf:resource="http://web.resource.org/cc/DerivativeWorks"/><requires rdf:resource="http://web.resource.org/cc/ShareAlike"/></License></rdf:RDF> -->

Last modified Mon Jun 16 12:48:53 2008
</p>
</body>
</html>
